;;; a-stern-gross-daten.scm

(define
  *knoten*
  '((A 138 40)
    (B 420 98)
    (C 631 93)
    (D 893 202)
    (E 66 153)
    (F 360 249)
    (G 665 245)
    (H 779 329)
    (I 87 319)
    (J 264 321)
    (K 427 342)
    (L 638 420)
    (M 919 430)
    (N 140 484)
    (O 338 397)
    (P 422 536)
    (Q 569 518)
    (R 748 516)
    (S 853 622)
    (T 183 639)
    (U 567 648))
  )

(define
  (gibX knoten-symbol)
  (second (assoc knoten-symbol *knoten*))
  )

(define
  (gibY knoten-symbol)
  (third (assoc knoten-symbol *knoten*))
  )

(define
  *kanten*
  '((A B 260)
    (A E 106)
    (B F 134)
    (B G 258)
    (B C 183)
    (C D 256)
    (C G 128)
    (G H 114)
    (D H 143)
    (F J 92)
    (F K 87)
    (J O 78)
    (K O 77)
    (E J 232)
    (E I 139)
    (I O 235)
    (I N 145)
    (A D 744)
    (G K 229)
    (G L 149)
    (H L 140)
    (L R 118)
    (M R 163)
    (M S 175)
    (S R 121)
    (R Q 151)
    (Q U 102)
    (Q P 120)
    (P U 155)
    (P T 232)
    (N T 133)
    (N G 549)
    (D R 318)
    (T S 642)
    (A F 277))
  )
;;; ===== Graphen mit ungerichteten Kanten gewaehrleisten =====
(define
  (ergaenze-um-rueckkanten kanten)
  (define
    (ergaenze-intern zu-bearbeiten akku)
    (cond
      ((null? zu-bearbeiten)
       akku)
      ((member ; Rueckkante schon drin?
        (list
         (second (first zu-bearbeiten))
         (first (first zu-bearbeiten))
         (third (first zu-bearbeiten)))
        kanten)
       (ergaenze-intern
        (rest zu-bearbeiten)
        (cons
         (first zu-bearbeiten)
         akku)))
      (else
       (ergaenze-intern
        (rest zu-bearbeiten)
        (cons
         (list
         (second (first zu-bearbeiten))
         (first (first zu-bearbeiten))
         (third (first zu-bearbeiten)))
         (cons
          (first zu-bearbeiten)
          akku))))
      ))
  (ergaenze-intern kanten '()))

; ===== Zugriffsfunktion =====
(define
  (gib-alle-kanten)
  (ergaenze-um-rueckkanten *kanten*))

; ===== Hilfsfunktion ist-nachfolge-kante? =====
(define
  (ist-nachfolge-kante? aktuelle-stadt kante)
  (equal? aktuelle-stadt (first kante)))

; ===== nachfolge-kanten endrekursiv mit Aufrufhuelle =====
(define
  (nachfolge-kanten aktuelle-stadt kanten)
  (define
    (intern aktuelle-stadt kanten akku)
    (cond
      ((null? kanten) (reverse akku))
      ((ist-nachfolge-kante? aktuelle-stadt (first kanten))
       (intern
        aktuelle-stadt
        (rest kanten)
        (cons (first kanten) akku)))
      (else (intern aktuelle-stadt (rest kanten) akku))
      )
    )
  (intern aktuelle-stadt kanten '())
  )

;;; Tests:
;(nachfolge-kanten 'A (gib-alle-kanten))
;(nachfolge-kanten 'I (gib-alle-kanten))