;;; wege.scm
;;; stellt die Funktionen fuer die Verwaltung der Wege bereit

;(load "gallenbacher-graph-kanten.scm")
; Verwendet wird davon die Kantenliste "kanten"
; und die Zugriffsfunktion (nachfolge-kanten <aktuelle-stadt> <kanten>)

; Wege sind Listen aus der aktuellen Laenge und den besuchten Knoten (rueckwaerts)
; Muster: (60 X B I)

;;; ===== alle-nachfolge-wege =====
(define
  (alle-nachfolge-wege weg kanten)
  (define
    (alle-intern nachfolger)
    (cond
      ((null? nachfolger) '())
      ((member (second (first nachfolger)) weg)
       (alle-intern (rest nachfolger)))
      (else
       (cons
        (neuer-weg weg (first nachfolger))
        (alle-intern (rest nachfolger))))
      ))
  (alle-intern
   (nachfolge-kanten
    (second weg) ; aktuelle-stadt steht nach der Laenge im weg
    kanten)))


;;; ===== Hilfsfunktion neuer-weg =====
; Gibt zu einem Weg und zu einer Kante den verlaengerten Weg zurueck.
(define
  (neuer-weg weg kante)
  (cons
     (+ (third kante) (first weg)) ; neue Weglaenge
     (cons
      (second kante) ; Zielort der Kante vorn einbauen
      (rest weg))))
;Tests:
; (neuer-weg '(34 B I) '(B X 26))
; -> '(60 X B I)

;;; ===== alle-nachfolge-wege =====
; Tests:
; (alle-nachfolge-wege '(22 N A) kanten)
; -> '((42 D N A) (51 X N A) (52 Z N A))
